library(lpSolve)
library(zoo)

#install.packages("lpSolve")
#install.packages("zoo")


N <- 24
I <- diag(rep(1,N))
LowTri <- lower.tri(matrix(1,ncol=N,nrow=N),diag=TRUE)
zeros <- diag(rep(0,N))
# x = (buy,sell,discharge,charge,slackbuy)


A <- rbind(rbind(cbind(cbind(cbind(cbind(-I,I),-I),I),-I),
                 cbind(cbind(cbind(cbind(zeros,zeros),-LowTri),0.9*LowTri),zeros),
                 cbind(cbind(cbind(cbind(zeros,zeros),LowTri),-0.9*LowTri),zeros),
                 cbind(cbind(cbind(cbind(I,zeros),zeros),zeros),zeros),
                 cbind(cbind(cbind(cbind(zeros,I),zeros),zeros),zeros),
                 cbind(cbind(cbind(cbind(zeros,zeros),I),zeros),zeros),
                 cbind(cbind(cbind(cbind(zeros,zeros),zeros),I),zeros),
                 cbind(cbind(cbind(cbind(I,zeros),zeros),zeros),zeros),
                 cbind(cbind(cbind(cbind(zeros,I),zeros),zeros),zeros),
                 cbind(cbind(cbind(cbind(zeros,zeros),I),zeros),zeros),
                 cbind(cbind(cbind(cbind(zeros,zeros),zeros),I),zeros),
                 cbind(cbind(cbind(cbind(zeros,zeros),zeros),zeros),I)))

ControlPVB <- function(bnmax,bpmax,buymax,sellmax,bmax,cB,PriceSale,N,lambdaB,b0,Hour,Price,Demand,Production){

  if(cB!=0.9){
    A[(N+1):(3*N),(3*N+1):(4*N)] <- rbind(cB*LowTri,-cB*LowTri)
  }


  Production <- Production/1000
  Demand <- Demand/1000
  ####

  f <- matrix(c(numeric(2*N),rep(lambdaB,N),-cB*rep(lambdaB,N),Price+10^5),ncol=1)
  ####

  f[1:(2*N)] <- c(Price,-PriceSale)

  b <- matrix(c(Production-Demand,rep(bmax,N)-b0,numeric(N)+b0,numeric(2*N),rep(bnmax,N),rep(bpmax,N),rep(0,5*N)),ncol=1)

  if(Hour==1){
  b[(3*N+1):(4*N)] <- buymax
  b[(4*N+1):(5*N)] <- sellmax}else{
  b[(3*N+1):(4*N)] <- c(buymax[Hour:N],buymax[1:(Hour-1)])
  b[(4*N+1):(5*N)] <- c(sellmax[Hour:N],sellmax[1:(Hour-1)])}


  Solution <- lp("min",f,A,c(rep("<=",7*N),rep(">=",5*N)),b)
  
  DCBS <- c(Solution$solution[(2*N+1)],Solution$solution[(3*N+1)],Solution$solution[1],Solution$solution[(N+1)],Solution$solution[(4*N+1)])
  
  return(matrix(DCBS,nrow=1))
}